/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1alpha1 "github.com/litmuschaos/chaos-operator/pkg/apis/litmuschaos/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeChaosResults implements ChaosResultInterface
type FakeChaosResults struct {
	Fake *FakeLitmuschaosV1alpha1
	ns   string
}

var chaosresultsResource = schema.GroupVersionResource{Group: "litmuschaos.io", Version: "v1alpha1", Resource: "chaosresults"}

var chaosresultsKind = schema.GroupVersionKind{Group: "litmuschaos.io", Version: "v1alpha1", Kind: "ChaosResult"}

// Get takes name of the chaosResult, and returns the corresponding chaosResult object, and an error if there is any.
func (c *FakeChaosResults) Get(name string, options v1.GetOptions) (result *v1alpha1.ChaosResult, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(chaosresultsResource, c.ns, name), &v1alpha1.ChaosResult{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ChaosResult), err
}

// List takes label and field selectors, and returns the list of ChaosResults that match those selectors.
func (c *FakeChaosResults) List(opts v1.ListOptions) (result *v1alpha1.ChaosResultList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(chaosresultsResource, chaosresultsKind, c.ns, opts), &v1alpha1.ChaosResultList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.ChaosResultList{ListMeta: obj.(*v1alpha1.ChaosResultList).ListMeta}
	for _, item := range obj.(*v1alpha1.ChaosResultList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested chaosResults.
func (c *FakeChaosResults) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(chaosresultsResource, c.ns, opts))

}

// Create takes the representation of a chaosResult and creates it.  Returns the server's representation of the chaosResult, and an error, if there is any.
func (c *FakeChaosResults) Create(chaosResult *v1alpha1.ChaosResult) (result *v1alpha1.ChaosResult, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(chaosresultsResource, c.ns, chaosResult), &v1alpha1.ChaosResult{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ChaosResult), err
}

// Update takes the representation of a chaosResult and updates it. Returns the server's representation of the chaosResult, and an error, if there is any.
func (c *FakeChaosResults) Update(chaosResult *v1alpha1.ChaosResult) (result *v1alpha1.ChaosResult, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(chaosresultsResource, c.ns, chaosResult), &v1alpha1.ChaosResult{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ChaosResult), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeChaosResults) UpdateStatus(chaosResult *v1alpha1.ChaosResult) (*v1alpha1.ChaosResult, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(chaosresultsResource, "status", c.ns, chaosResult), &v1alpha1.ChaosResult{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ChaosResult), err
}

// Delete takes name of the chaosResult and deletes it. Returns an error if one occurs.
func (c *FakeChaosResults) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(chaosresultsResource, c.ns, name), &v1alpha1.ChaosResult{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeChaosResults) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(chaosresultsResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &v1alpha1.ChaosResultList{})
	return err
}

// Patch applies the patch and returns the patched chaosResult.
func (c *FakeChaosResults) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.ChaosResult, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(chaosresultsResource, c.ns, name, pt, data, subresources...), &v1alpha1.ChaosResult{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ChaosResult), err
}
